function [x,flag,relres,iter] = SolveLinearSystem(A,b,n,x,tol,LSopt)

maxit = 2*n;

% LSopt = 1: bicg        - BiConjugate Gradients Method.
% LSopt = 2: bicgstab    - BiConjugate Gradients Stabilized Method.
% LSopt = 3: bicgstabl   - BiCGStab(l) Method.
% LSopt = 4: cgs         - Conjugate Gradients Squared Method.
% LSopt = 5: gmres       - Generalized Minimum Residual Method.
% LSopt = 6: lsqr        - LSQR Method.
% LSopt = 7: qmr         - Quasi-Minimal Residual Method.
% LSopt = 8: tfqmr       - Transpose-Free QMR Method.


% (A,b,tol,maxit,M1,M2,x0)

if LSopt == 1
    [x,flag,relres,iter] = bicg(A,b,tol,maxit,[],[],x);
    
elseif LSopt == 2
    [x,flag,relres,iter] = bicgstab(A,b,tol,maxit,[],[],x);
    
elseif LSopt == 3
    [x,flag,relres,iter] = bicgstabl(A,b,tol,maxit,[],[],x);
    
elseif LSopt == 4
    [x,flag,relres,iter] = cgs(A,b,tol,maxit,[],[],x);
    
elseif LSopt == 5
    restart = n;
    maxit = n;
    [x,flag,relres,iter] = gmres(A,b,restart,tol,maxit,[],[],x);
    iter = iter(1) * iter(2);
    
elseif LSopt == 6
    [x,flag,relres,iter] = lsqr(A,b,tol,maxit,[],[],x);
    
elseif LSopt == 7
    [x,flag,relres,iter] = qmr(A,b,tol,maxit,[],[],x);
    
elseif LSopt == 8
   [x,flag,relres,iter] = tfqmr(A,b,tol,maxit,[],[],x);
   
end
            
            
        
        
        